//+------------------------------------------------------------------+
//|                                    Moving average strategery.mq4 |
//|                                                         Ken Beck |
//|                                                    www.fsifx.com |
//+------------------------------------------------------------------+
#property copyright "Ken Beck"
#property link      "www.fsifx.com"
#include <stdlib.mqh>
#include <IncludeFile.mqh>
//--- input parameters

//--external parameters
extern double  StopLoss= 300;
extern double  TakeProfit=450;
extern int     TrailingStop=100;
extern int     MinimumProfit=200;
extern int     MagicNumber= 426;
extern double  MAPeriod=20;
extern double  VicOne=100;
extern double  VicTwo=200;
extern double  MAFrame=5;
extern int     MAMethod= 1;
extern int     MAPrice= 0;
extern double  Lots= 0.03;

//Global Variables
int BuyTicket;
int SellTicket;


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
 //Moving Average
     double MovingAverage=iMA( Symbol(), MAFrame, MAPeriod,  10,  MAMethod,  MAPrice,  0);
     double Spread=  MarketInfo( Symbol(),  MODE_SPREAD); 
 //Order Prices & Stops
      double BuyStopPrice= NormalizeDouble(MovingAverage+((Spread+10)*Point),5);
      double SellStopPrice= NormalizeDouble(MovingAverage-((Spread+10)*Point),5);
      double SellStopLoss=NormalizeDouble(Bid+(StopLoss*Point),5);
      double SellTakeProfit= NormalizeDouble(Bid-(TakeProfit*Point),5);
      double BuyStopLoss=NormalizeDouble(Ask-(StopLoss*Point),5);
      double BuyTakeProfit=NormalizeDouble(Ask+(TakeProfit*Point),5);
 // General
 
 //Counter
 //SELL ORDER 
      if(SellStopPrice==Ask && OrdersTotal()<1 && SellTicket==0)  
       {
         SellTicket= OrderSend(Symbol(),OP_SELL,Lots,Bid,5,SellStopLoss,SellTakeProfit,NULL,MagicNumber,0,Pink);
          
          BuyTicket=0;
         //Sell Profit Trap
         if(OrdersTotal()>0)
          {
          SellTrailingStop(Symbol(), TrailingStop, MinimumProfit, MagicNumber);
          }
          string OrderLog= StringConcatenate("symbol is: ", OrderSymbol(),"ordertype is: ", OrderType(), "number of lots is: ",
                           Lots, "OrderPrice is: ", OrderOpenPrice(),"stop loss is: ", OrderStopLoss(), "take profit: ", OrderTakeProfit(),
                           "magic number: ", OrderMagicNumber());
           Print(OrderLog);
      
            if(SellTicket==false)
            {   
            int ErrorCode=GetLastError();
            string ErrDesc= ErrorDescription(ErrorCode);
            string ErrorAlert=StringConcatenate("Order Send- ERROR", ": ", ErrDesc);
            Alert(ErrorAlert);
  
            string ErrLog =StringConcatenate("Bid: ", MarketInfo(OrderSymbol(),MODE_BID),"Ask: ", MarketInfo(OrderSymbol(),MODE_ASK),
                                   "Ticket: ", OrderTicket(), "stop: ", OrderStopLoss(), "Take Profit: ", OrderTakeProfit());
            Print(ErrLog); 
            
         }
        }
         
           
         
 //BUY ORDER       
      if(BuyStopPrice==Bid && OrdersTotal()<1 && BuyTicket==0)   
       {
       
      BuyTicket= OrderSend(Symbol(),OP_BUY,Lots,Ask,5,BuyStopLoss,BuyTakeProfit,NULL,MagicNumber,0,Green);
      SellTicket=0;
          if(OrdersTotal()>0)
          {
          BuyTrailingStop(Symbol(), TrailingStop, MinimumProfit, MagicNumber);
          OrderLog= StringConcatenate("symbol is: ", OrderSymbol(),"ordertype is: ", OrderType(), "number of lots is: ",
                           Lots, "OrderPrice is: ", OrderOpenPrice(),"stop loss is: ", OrderStopLoss(), "take profit: ", OrderTakeProfit(),
                           "magic number: ", OrderMagicNumber());
           Print(OrderLog);
          
          if(BuyTicket==false)
            {   
             ErrorCode=GetLastError();
             ErrDesc= ErrorDescription(ErrorCode);
             ErrorAlert=StringConcatenate("Order Send- ERROR", ": ", ErrDesc);
            Alert(ErrorAlert);
  
             ErrLog =StringConcatenate("Bid: ", MarketInfo(OrderSymbol(),MODE_BID),"Ask: ", MarketInfo(OrderSymbol(),MODE_ASK),
                                   "Ticket: ", OrderTicket(), "stop: ", OrderStopLoss(), "Take Profit: ", OrderTakeProfit());
            Print(ErrLog); 
            }
          }
       }
 
 
 
 
   return(0);
   }
   //+------------------------------------------------------------------+